
<p>Opet smo u nekoj proizvoljnoj bazi. Za početak, razmišljajte o dekadskim brojevima. Prisjetite se osnovne škole i postupka zbrajanja višeznamenkastih brojeva: brojeve treba potpisati jedan ispod drugoga i poravnati tako da znamenke istih težina budu jedna ispod druge.<p>

<p>Potom, neovisno o tome koliko brojevi imaju znamenaka, provodimo postupak zbrajanja koji u svakom trenutku gleda samo jednu poziciju. Krećemo od znamenaka pribrojnika na najmanjoj poziciji i računamo njihov zbroj. Znamenku rezultata pišemo u redak rezultata na istu poziciju i pamtimo kakav je bio prijenos.</p>

<p>Potom se pomičemo za jedno mjesto u lijevo (prema značajnijim pozicijama): gledamo koje dvije znamenke tu zapisane. Sada, međutim, ne smijemo samo računati njihov zbroj, već moramo zbrojiti tri vrijednosti: znamenku prvog broja, znamenku drugog broja te prijenos koji je zbrajanje na prethodnoj poziciji generiralo. Za taj zbroj znamenku rezultata zapisujemo u redak rezultata i pamtimo novi prijenos. Opet se pomičemo za jedno mjesto u lijevo i ponavljamo postupak sve dok ima mjesta na koja se možemo pomaknuti.</p>

<p>Grafički prikaz zbrajanja dvaju peteroznamenkastih dekadskih brojeva prikazan je na slici u nastavku. Prijenosi su prikazani iznad znamenaka.</p>

<figure class="mlFigure">
<img src="@#file#(zbrajanje.svg)" alt="Zbrajanje višeznamenkastih dekadskih brojeva"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Zbrajanje višeznamenkastih dekadskih brojeva.</figcaption>
</figure>

<p>Potpuno jednak postupak vrijedi i u bilo kojoj drugoj bazi. Primjer zbrajanja dvaju peteroznamenkastih binarnih brojeva prikazan je na slici 2.</p>

<figure class="mlFigure">
<img src="@#file#(zbrajanje2.svg)" alt="Zbrajanje višeznamenkastih binarnih brojeva"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Zbrajanje višeznamenkastih binarnih brojeva.</figcaption>
</figure>

<p>Ovaj postupak možemo lijepo i programski ilustrirati. Ilustrativna programska implementacija postupka zbrajanja u programskom jeziku C prikazana je u nastavku.</p>

<pre><code>#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;

#define BROJ_ZNAMENKI 5
#define BAZA 10

void main() {
  /* Znamenke pribrojnika; na poziciji 0 je znamenka najmanje težine. */
  int a[BROJ_ZNAMENKI] = {2, 7, 6, 3, 1};
  int b[BROJ_ZNAMENKI] = {5, 8, 5, 2, 3};
  int c;
  int r[BROJ_ZNAMENKI];
  
  c = 0; /* Početni prijenos je 0. */

  /* Zbrajanje: */
  for(int i = 0; i &lt; BROJ_ZNAMENKI; i++) {
    r[i] = (a[i] + b[i] + c) % BAZA;
    c = (a[i] + b[i] + c) / BAZA;
  }
  
  /* Ispis rezultata: */
  for(int i = BROJ_ZNAMENKI-1; i &gt;= 0; i--) {
    printf("%d", r[i]);
  }
  printf("\n");
}</code></pre>

<p>Prikazana implementacija varijablu <code>c</code> koristi za privremenu pohranu prijenosa iz jedne iteracije petlje u drugu. Inačica koda koja svaki od prijenosa čuva na zasebnom mjestu prikazana je u nastavku.</p>

<pre><code>#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;

#define BROJ_ZNAMENKI 5
#define BAZA 10

void main() {
  /* Znamenke pribrojnika; na poziciji 0 je znamenka najmanje težine. */
  int a[BROJ_ZNAMENKI] = {2, 7, 6, 3, 1};
  int b[BROJ_ZNAMENKI] = {5, 8, 5, 2, 3};
  /* Prijenosi i znamenke rezultata. */
  int c[BROJ_ZNAMENKI+1];
  int r[BROJ_ZNAMENKI];
  
  c[0] = 0; /* Početni prijenos je 0. */

  /* Zbrajanje: */
  for(int i = 0; i &lt; BROJ_ZNAMENKI; i++) {
    r[i] = (a[i] + b[i] + c[i]) % BAZA;
    c[i+1] = (a[i] + b[i] + c[i]) / BAZA;
  }
  
  /* Ispis rezultata: */
  for(int i = BROJ_ZNAMENKI-1; i &gt;= 0; i--) {
    printf("%d", r[i]);
  }
  printf("\n");
}</code></pre>

<p>Pogledajmo sada što se događa u <i>i</i>-toj iteraciji petlje. Izvode se dva izraza:</p>

<pre><code>r[i] = (a[i] + b[i] + c[i]) % BAZA;
c[i+1] = (a[i] + b[i] + c[i]) / BAZA;
</code></pre>

<p>Na temelju <i>i</i>-te znamenke broja <i>a</i> i <i>i</i>-te znamenke broja <i>b</i> i prijenosa koji dolazi na <i>i</i>-tu poziciju računa se znamenka rezultata za <i>i</i>-tu poziciju te prijenos za <i>i</i>+1 poziciju. Ova operacija dosta je slična onoj koju je računalo poluzbrajalo. Međutim, poluzbrajalo je imalo samo dva ulaza. Sada nam treba sklop koji može dobiti znamenku prvog broja, znamenku drugog broja te ulazni prijenos pa izračunati njihovu sumu i potom generirati znamenku rezultata i izlazni prijenos. Takav sklop naziva se potpuno zbrajalo.</p>









